
/*
 * Generated data (by mkcproc.pl)
 */
#line 1 "bsewave.proc"
// Licensed GNU LGPL v2.1 or later: http://www.gnu.org/licenses/lgpl.html
#include <bse/bseplugin.hh>
#include <bse/bseprocedure.hh>
#include <bse/bsewave.hh>
#include <bse/bseeditablesample.hh>
#include "bsebuiltin_externs.cc"


#line 11 "bsewave.proc"


/* --- n-wave-chunks --- */
static void
n_wave_chunks_setup (BseProcedureClass *proc, GParamSpec **in_pspecs, GParamSpec **out_pspecs) {
#line 13 "bsewave.proc"
 {
#line 15 "bsewave.proc"
  *(in_pspecs++)    = bse_param_spec_object ("wave", "Wave", NULL,
				 BSE_TYPE_WAVE, SFI_PARAM_STANDARD);
  *(out_pspecs++)   = sfi_pspec_int ("n_chunks", "Number of Wave Chunks", NULL,
			 0, 0, G_MAXINT, 1, SFI_PARAM_STANDARD);
}
#line 20 "bsewave.proc"
 }
static Bse::Error
#line 20 "bsewave.proc"
n_wave_chunks_exec (BseProcedureClass *proc,
      const GValue      *in_values,
      GValue            *out_values)
#line 23 "bsewave.proc"
{
#line 24 "bsewave.proc"
  
  BseWave *wave = (BseWave*) bse_value_get_object (in_values++);

#line 27 "bsewave.proc"
  
  if (!BSE_IS_WAVE (wave))
    return Bse::Error::PROC_PARAM_INVAL;

#line 31 "bsewave.proc"
  
  sfi_value_set_int (out_values++, wave->n_wchunks);

  return Bse::Error::NONE;
}

/* --- use-editable --- */
static void
use_editable_setup (BseProcedureClass *proc, GParamSpec **in_pspecs, GParamSpec **out_pspecs) {
#line 37 "bsewave.proc"
 {
#line 39 "bsewave.proc"
  *(in_pspecs++)    = bse_param_spec_object ("wave", "Wave", NULL,
				 BSE_TYPE_WAVE, SFI_PARAM_STANDARD);
  *(in_pspecs++)    = sfi_pspec_int ("chunk_index", NULL, "Index of chunk to edit",
			 0, 0, G_MAXINT, 1, SFI_PARAM_STANDARD);
  *(out_pspecs++)   = bse_param_spec_object ("esample", NULL, "Editable sample",
				 BSE_TYPE_EDITABLE_SAMPLE, SFI_PARAM_STANDARD);
}
#line 46 "bsewave.proc"
 }
static Bse::Error
#line 46 "bsewave.proc"
use_editable_exec (BseProcedureClass *proc,
      const GValue      *in_values,
      GValue            *out_values)
#line 49 "bsewave.proc"
{
#line 50 "bsewave.proc"
  
  BseWave *wave = (BseWave*) bse_value_get_object (in_values++);
  guint chunk_index = sfi_value_get_int (in_values++);
  BseEditableSample *esample = NULL;
  GslWaveChunk *wchunk = NULL;

#line 56 "bsewave.proc"
  
  if (!BSE_IS_WAVE (wave))
    return Bse::Error::PROC_PARAM_INVAL;

  wchunk = (GslWaveChunk*) sfi_ring_nth_data (wave->wave_chunks, chunk_index);
  if (wchunk)
    {
      esample = (BseEditableSample*) bse_object_new (BSE_TYPE_EDITABLE_SAMPLE, NULL);
      bse_editable_sample_set_wchunk (esample, wchunk);
      bse_item_use (BSE_ITEM (esample));
      g_object_unref (esample);
    }

#line 69 "bsewave.proc"
  
  bse_value_set_object (out_values++, esample);

  return Bse::Error::NONE;
}

/* --- chunk-get-osc-freq --- */
static void
chunk_get_osc_freq_setup (BseProcedureClass *proc, GParamSpec **in_pspecs, GParamSpec **out_pspecs) {
#line 75 "bsewave.proc"
 {
#line 77 "bsewave.proc"
  *(in_pspecs++)    = bse_param_spec_object ("wave", "Wave", NULL,
				 BSE_TYPE_WAVE, SFI_PARAM_STANDARD);
  *(in_pspecs++)    = sfi_pspec_int ("chunk_index", "Chunk Index", "Index of chunk",
			 0, 0, G_MAXINT, 1, SFI_PARAM_STANDARD);
  *(out_pspecs++)   = sfi_pspec_real ("osc_freq", NULL, NULL,
			  BSE_KAMMER_FREQUENCY, BSE_MIN_OSC_FREQUENCY, BSE_MAX_OSC_FREQUENCY, 10.0,
			  SFI_PARAM_STANDARD);
}
#line 85 "bsewave.proc"
 }
static Bse::Error
#line 85 "bsewave.proc"
chunk_get_osc_freq_exec (BseProcedureClass *proc,
      const GValue      *in_values,
      GValue            *out_values)
#line 88 "bsewave.proc"
{
#line 89 "bsewave.proc"
  
  BseWave *wave = (BseWave*) bse_value_get_object (in_values++);
  guint chunk_index = sfi_value_get_int (in_values++);
  GslWaveChunk *wchunk = NULL;

#line 94 "bsewave.proc"
  
  if (!BSE_IS_WAVE (wave))
    return Bse::Error::PROC_PARAM_INVAL;

  wchunk = (GslWaveChunk*) sfi_ring_nth_data (wave->wave_chunks, chunk_index);
  if (wchunk)
    sfi_value_set_real (out_values++, wchunk->osc_freq);

  return Bse::Error::NONE;
}

/* --- chunk-get-mix-freq --- */
static void
chunk_get_mix_freq_setup (BseProcedureClass *proc, GParamSpec **in_pspecs, GParamSpec **out_pspecs) {
#line 105 "bsewave.proc"
 {
#line 107 "bsewave.proc"
  *(in_pspecs++)    = bse_param_spec_object ("wave", "Wave", NULL,
				 BSE_TYPE_WAVE, SFI_PARAM_STANDARD);
  *(in_pspecs++)    = sfi_pspec_int ("chunk_index", "Chunk Index", "Index of chunk",
			 0, 0, G_MAXINT, 1, SFI_PARAM_STANDARD);
  *(out_pspecs++)   = sfi_pspec_real ("mix_freq", NULL, NULL,
#line 112 "bsewave.proc"
			  0, 0, 44100 * 16 , 10.0,
			  SFI_PARAM_STANDARD);
}
#line 115 "bsewave.proc"
 }
static Bse::Error
#line 115 "bsewave.proc"
chunk_get_mix_freq_exec (BseProcedureClass *proc,
      const GValue      *in_values,
      GValue            *out_values)
#line 118 "bsewave.proc"
{
#line 119 "bsewave.proc"
  
  BseWave *wave = (BseWave*) bse_value_get_object (in_values++);
  guint chunk_index = sfi_value_get_int (in_values++);
  GslWaveChunk *wchunk = NULL;

#line 124 "bsewave.proc"
  
  if (!BSE_IS_WAVE (wave))
    return Bse::Error::PROC_PARAM_INVAL;

  wchunk = (GslWaveChunk*) sfi_ring_nth_data (wave->wave_chunks, chunk_index);
  if (wchunk)
    sfi_value_set_real (out_values++, wchunk->mix_freq);

  return Bse::Error::NONE;
}

/* --- Export to BSE --- */
static void
__enode_n_wave_chunks__fill_strings (BseExportStrings *es)
{
  es->blurb = "Get the number of wave chunks of a wave";
  es->file = "/opt/src/beast/bse/bsewave.proc";
  es->line = 14;
  es->authors = "Tim Janik <timj@gtk.org>";
  es->license = "GNU Lesser General Public License";
}
static BseExportNodeProc __enode_n_wave_chunks = {
  { NULL, BSE_EXPORT_NODE_PROC,
    "BseWave+n-wave-chunks", 
    NULL,
    "/Methods/BseWave/General/N Wave Chunks",
    NULL,
    __enode_n_wave_chunks__fill_strings,
  },
  0, n_wave_chunks_setup, n_wave_chunks_exec, 
};
static void
__enode_use_editable__fill_strings (BseExportStrings *es)
{
  es->blurb = "Retrieve an editable sample object for a wave chunk.";
  es->file = "/opt/src/beast/bse/bsewave.proc";
  es->line = 38;
  es->authors = "Tim Janik <timj@gtk.org>";
  es->license = "GNU Lesser General Public License";
}
static BseExportNodeProc __enode_use_editable = {
  { (BseExportNode*) &__enode_n_wave_chunks, BSE_EXPORT_NODE_PROC,
    "BseWave+use-editable", 
    NULL,
    "/Methods/BseWave/General/Use Editable",
    NULL,
    __enode_use_editable__fill_strings,
  },
  0, use_editable_setup, use_editable_exec, 
};
static void
__enode_chunk_get_osc_freq__fill_strings (BseExportStrings *es)
{
  es->blurb = "Retrieve oscillating frequency of a wave chunk.";
  es->file = "/opt/src/beast/bse/bsewave.proc";
  es->line = 76;
  es->authors = "Tim Janik <timj@gtk.org>";
  es->license = "GNU Lesser General Public License";
}
static BseExportNodeProc __enode_chunk_get_osc_freq = {
  { (BseExportNode*) &__enode_use_editable, BSE_EXPORT_NODE_PROC,
    "BseWave+chunk-get-osc-freq", 
    NULL,
    "/Methods/BseWave/General/Chunk Get Osc Freq",
    NULL,
    __enode_chunk_get_osc_freq__fill_strings,
  },
  0, chunk_get_osc_freq_setup, chunk_get_osc_freq_exec, 
};
static void
__enode_chunk_get_mix_freq__fill_strings (BseExportStrings *es)
{
  es->blurb = "Retrieve mixing frequency of a wave chunk.";
  es->file = "/opt/src/beast/bse/bsewave.proc";
  es->line = 106;
  es->authors = "Tim Janik <timj@gtk.org>";
  es->license = "GNU Lesser General Public License";
}
static BseExportNodeProc __enode_chunk_get_mix_freq = {
  { (BseExportNode*) &__enode_chunk_get_osc_freq, BSE_EXPORT_NODE_PROC,
    "BseWave+chunk-get-mix-freq", 
    NULL,
    "/Methods/BseWave/General/Chunk Get Mix Freq",
    NULL,
    __enode_chunk_get_mix_freq__fill_strings,
  },
  0, chunk_get_mix_freq_setup, chunk_get_mix_freq_exec, 
};
extern "C" BseExportNode* bse__builtin_init_bsewave_genprc_cc (void)
{
  return (BseExportNode*) &__enode_chunk_get_mix_freq;
}

/*
 * Generated data ends here
 */
